CREATE OR REPLACE PROCEDURE LIMPEZA_VENDAS(
   P_NRLISTA       IN VARCHAR2,
   P_DTFINAL       IN DATE,
   P_DSSISTLIMPEZ  IN VARCHAR2,
   P_NMOPERLIMPEZ  IN VARCHAR2,
   P_IDSISTEMA     IN VARCHAR2)
AS
   V_ERROR             VARCHAR2(2000);
   V_NRORDEM           VARCHAR2(03);
   V_DSIP              VARCHAR2(50);
   V_DSUSUARIO         VARCHAR2(50);
   V_DSRDM             VARCHAR2(50);
   V_DSMETODO          VARCHAR2(250);
   V_DSOPERADOR        VARCHAR2(12);

   V_COUNT_COMMIT      NUMBER := 1;
   V_NUM_TO_COMMIT     NUMBER := 1000; -- NUMERO UTILIZADO PARA REGULARIZAR A QUANTIDADE DE DMLS PARA O COMMIT.

   V_EXCLUTURCAIXA     NUMBER := 0;
   V_EXCLUMOVCAIXA     NUMBER := 0;
   V_EXCLUMOVICLIE     NUMBER := 0;
   V_EXCLUVENDA        NUMBER := 0;
   V_EXCLUITEMVENDA    NUMBER := 0;

   V_CDFILIAL          VARCHAR2(4);
   
   V_DTHRFINLIMPEZA  DATE;   

   CURSOR C_LISTA IS (SELECT CDLISTA AS CDFILIAL
                      FROM LISTA
                      WHERE NRLISTA = P_NRLISTA);
                      
   PROCEDURE VerifTimeOut(DTLIMITE IN DATE)
   IS
   BEGIN
      IF SYSDATE > DTLIMITE THEN
         RAISE_APPLICATION_ERROR(-20001,'TIMEOUT - EXCEO PROPOSITAL TEKNISA');
      END IF;
   END;                      

BEGIN

   WEBTUNNING(V_DSIP, V_DSUSUARIO, V_DSRDM, V_DSMETODO, V_DSOPERADOR);

   V_NRORDEM := '0';
   
   DELETE FROM TRABPROCLIMPEZA
   WHERE IDLIMPEZA = P_IDSISTEMA;    

   UPDATE TRABLIMPEZA
      SET IDSTATUSLIMPEZA = 'A'
    WHERE IDLIMPEZA = P_IDSISTEMA;

   COMMIT;

   /* TABELA SOLICITA  */
   V_NRORDEM := LPAD(TO_CHAR(TO_NUMBER(V_NRORDEM)+1), 3, '0');

   UPDATE TABLIMPEZA
      SET NRORDEMLIMPEZA = V_NRORDEM
    WHERE IDLIMPEZA = P_IDSISTEMA
      AND NMTABELALIMP = 'TURCAIXA';

   IF NOT(SQL%ROWCOUNT > 0) THEN
      INSERT INTO TABLIMPEZA
      VALUES
      (P_IDSISTEMA, 'TURCAIXA', V_NRORDEM);
   END IF;

   INSERT INTO TRABPROCLIMPEZA
     (IDLIMPEZA, NMTABELALIMP, IDSITUPROCLIMP)
   VALUES
      (P_IDSISTEMA, 'TURCAIXA', 'A');

   COMMIT;

   OPEN C_LISTA;
   LOOP
      FETCH C_LISTA INTO V_CDFILIAL;
      EXIT WHEN C_LISTA%NOTFOUND;

      FOR C_TURCAIXA IN (SELECT CDFILIAL, CDCAIXA, DTABERCAIX, ROWID AS LINHA
                           FROM TURCAIXA
                          WHERE TURCAIXA.DTMOVTURCAIX < P_DTFINAL
                            AND TURCAIXA.CDFILIAL = V_CDFILIAL)
      LOOP
          DELETE FROM FECHACAIXA
          WHERE CDFILIAL = C_TURCAIXA.CDFILIAL AND
                CDCAIXA = C_TURCAIXA.CDCAIXA AND
                DTABERCAIX = C_TURCAIXA.DTABERCAIX;

          DELETE FROM EXTRATOCONS
          WHERE CDFILIAL = C_TURCAIXA.CDFILIAL AND
                CDCAIXA = C_TURCAIXA.CDCAIXA AND
                DTABERCAIX = C_TURCAIXA.DTABERCAIX;

          DELETE FROM TURCAIXATMP
          WHERE CDFILIAL = C_TURCAIXA.CDFILIAL AND
                CDCAIXA = C_TURCAIXA.CDCAIXA AND
                DTABERCAIX = C_TURCAIXA.DTABERCAIX;

          /*Movimentao do caixa*/
          FOR C_MOVCAIXA IN (SELECT CDFILIAL, CDCAIXA, DTABERCAIX, NRSEQUMOVI, ROWID AS LINHA
                               FROM MOVCAIXA
                              WHERE CDFILIAL   = C_TURCAIXA.CDFILIAL AND
                                    CDCAIXA    = C_TURCAIXA.CDCAIXA  AND
                                    DTABERCAIX = C_TURCAIXA.DTABERCAIX)
          LOOP

             /*Movimentao do cliente*/
             DELETE FROM MOVICLIE
             WHERE CDFILIAL = C_MOVCAIXA.CDFILIAL AND
                   CDCAIXA = C_MOVCAIXA.CDCAIXA AND
                   DTABERCAIX = C_MOVCAIXA.DTABERCAIX AND
                   NRSEQUMOVI = C_MOVCAIXA.NRSEQUMOVI;

             V_EXCLUMOVICLIE := SQL%ROWCOUNT + V_EXCLUMOVICLIE;

             DELETE FROM MOVCAIXA
             WHERE ROWID = C_MOVCAIXA.LINHA;

             V_EXCLUMOVCAIXA := SQL%ROWCOUNT + V_EXCLUMOVCAIXA;

          END LOOP;

          /*Vendas*/
          FOR C_VENDA IN (SELECT CDFILIAL, CDCAIXA, NRSEQVENDA, ROWID AS LINHA
                            FROM VENDA
                           WHERE CDFILIAL = C_TURCAIXA.CDFILIAL AND
                                 CDCAIXA = C_TURCAIXA.CDCAIXA  AND
                                 DTABERTUR = C_TURCAIXA.DTABERCAIX)
          LOOP

             /*Movimentao do caixa*/
             DELETE FROM MOVCAIXA
             WHERE CDFILIAL = C_VENDA.CDFILIAL AND
                   CDCAIXA  = C_VENDA.CDCAIXA  AND
                   NRSEQVENDA = C_VENDA.NRSEQVENDA;

             V_EXCLUMOVCAIXA := SQL%ROWCOUNT + V_EXCLUMOVCAIXA;

             /*Imposto dos itens */
             DELETE FROM ITVENDAIMPOS
             WHERE CDFILIAL = C_VENDA.CDFILIAL AND
                   CDCAIXA  = C_VENDA.CDCAIXA  AND
                   NRSEQVENDA = C_VENDA.NRSEQVENDA;

             /*Itens da venda*/
             DELETE FROM ITEMVENDA
             WHERE CDFILIAL   = C_VENDA.CDFILIAL AND
                   CDCAIXA    = C_VENDA.CDCAIXA  AND
                   NRSEQVENDA = C_VENDA.NRSEQVENDA;

             V_EXCLUITEMVENDA := SQL%ROWCOUNT + V_EXCLUITEMVENDA;

             /*Movimentao do cliente*/
             DELETE FROM MOVICLIE
             WHERE CDFILIAL = C_VENDA.CDFILIAL AND
                   CDCAIXA  = C_VENDA.CDCAIXA  AND
                   NRSEQVENDA = C_VENDA.NRSEQVENDA;

             V_EXCLUMOVICLIE := SQL%ROWCOUNT + V_EXCLUMOVICLIE;

             /* PARCELA VENDAS*/
             DELETE FROM PARCELAVENDA
             WHERE CDFILIAL = C_VENDA.CDFILIAL AND
                   CDCAIXA = C_VENDA.CDCAIXA  AND
                   NRSEQVENDA = C_VENDA.NRSEQVENDA;

             DELETE FROM COMPITVENDA
             WHERE CDFILIAL = C_VENDA.CDFILIAL AND
                   CDCAIXA = C_VENDA.CDCAIXA  AND
                   NRSEQVENDA = C_VENDA.NRSEQVENDA;

             /*Itens cancelados*/
             DELETE FROM ITVENDACAN
             WHERE CDFILIAL   = C_VENDA.CDFILIAL AND
                   CDCAIXA    = C_VENDA.CDCAIXA  AND
                   NRSEQVENDA = C_VENDA.NRSEQVENDA;

             DELETE FROM EXTRATOCONS
             WHERE CDFILIAL = C_VENDA.CDFILIAL AND
                   CDCAIXA = C_VENDA.CDCAIXA  AND
                   NRSEQVENDA = C_VENDA.NRSEQVENDA;

             DELETE FROM VENDA
             WHERE ROWID = C_VENDA.LINHA;
             V_EXCLUVENDA := SQL%ROWCOUNT + V_EXCLUVENDA;

          END LOOP;

          /*Fechamento de caixa */
          DELETE FROM FECHACAIXA
          WHERE CDFILIAL   = C_TURCAIXA.CDFILIAL AND
                CDCAIXA    = C_TURCAIXA.CDCAIXA  AND
                DTABERCAIX = C_TURCAIXA.DTABERCAIX;

          DELETE TURCAIXA
          WHERE ROWID = C_TURCAIXA.LINHA;
          V_EXCLUTURCAIXA := SQL%ROWCOUNT + V_EXCLUTURCAIXA;
          
          IF V_COUNT_COMMIT >= V_NUM_TO_COMMIT THEN

            UPDATE TRABPROCLIMPEZA
              SET QTREGEXCLIMPEZA = V_EXCLUTURCAIXA
            WHERE IDLIMPEZA = P_IDSISTEMA
              AND NMTABELALIMP = 'TURCAIXA';

            V_COUNT_COMMIT:= 1;
            COMMIT;
            /*Verifica se a procedure estourou o tempo limite*/
            VERIFTIMEOUT(V_DTHRFINLIMPEZA);                  
          ELSE
            V_COUNT_COMMIT:= V_COUNT_COMMIT + 1;
          END IF;

      END LOOP;
   END LOOP;   

   CLOSE C_LISTA;

   /* COLOCA O STATUS DA TABELA DE LIMPEZA PARA CONCLUIDO */
   UPDATE TRABPROCLIMPEZA
      SET IDSITUPROCLIMP = 'C',
          QTREGEXCLIMPEZA = V_EXCLUTURCAIXA,
          DTHRFINLIMPEZA = SYSDATE
    WHERE IDLIMPEZA = P_IDSISTEMA AND
          NMTABELALIMP = 'TURCAIXA';

   /*deleta a tabela temporaria da limpeza */
   UPDATE TRABLIMPEZA
   SET IDSTATUSLIMPEZA = 'C'
   WHERE IDLIMPEZA = P_IDSISTEMA;

   COMMIT;   

   INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES (P_DSSISTLIMPEZ, 'TURCAIXA', SYSDATE, P_NMOPERLIMPEZ, P_DTFINAL, 'TURCAIXA', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUTURCAIXA);

   INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES (P_DSSISTLIMPEZ, 'MOVICLIE', SYSDATE, P_NMOPERLIMPEZ, P_DTFINAL, 'MOVICLIE', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUMOVICLIE);

   INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES (P_DSSISTLIMPEZ, 'MOVCAIXA', SYSDATE, P_NMOPERLIMPEZ, P_DTFINAL, 'MOVCAIXA', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUMOVCAIXA);

   INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES (P_DSSISTLIMPEZ, 'VENDA', SYSDATE, P_NMOPERLIMPEZ, P_DTFINAL, 'VENDA', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUVENDA);

   INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES (P_DSSISTLIMPEZ, 'ITEMVENDA', SYSDATE, P_NMOPERLIMPEZ, P_DTFINAL, 'ITEMVENDA', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUITEMVENDA);

   /*Apagando a lista utilizada para a limpeza*/
   DELETE FROM LISTA
   WHERE NRLISTA =P_NRLISTA;
  
   COMMIT;      

EXCEPTION
  WHEN OTHERS THEN
   V_ERROR:= SQLERRM(SQLCODE);
   
   IF INSTR(V_ERROR, 'TIMEOUT - EXCEO PROPOSITAL TEKNISA') = 0 THEN
      /*Apagando a lista utilizada para a limpeza*/
      DELETE FROM LISTA
      WHERE NRLISTA =P_NRLISTA;
      
      UPDATE TRABLIMPEZA
      SET IDSTATUSLIMPEZA = 'C'
      WHERE IDLIMPEZA = P_IDSISTEMA;  
      
      COMMIT;   
   ELSE    
       UPDATE TRABLIMPEZA
       SET IDSTATUSLIMPEZA = 'P'
       WHERE IDLIMPEZA = P_IDSISTEMA;  
   END IF;   


   IF (V_EXCLUTURCAIXA = 0) THEN
      INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
      VALUES (P_DSSISTLIMPEZ, 'TURCAIXA', SYSDATE, P_NMOPERLIMPEZ, P_DTFINAL, 'TURCAIXA', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUTURCAIXA);
   END IF;

   IF (V_EXCLUMOVICLIE = 0) THEN
      INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
      VALUES (P_DSSISTLIMPEZ, 'MOVICLIE', SYSDATE, P_NMOPERLIMPEZ, P_DTFINAL, 'MOVICLIE', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUMOVICLIE);
   END IF;

   IF (V_EXCLUMOVCAIXA = 0) THEN
      INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
      VALUES (P_DSSISTLIMPEZ, 'MOVCAIXA', SYSDATE, P_NMOPERLIMPEZ, P_DTFINAL, 'MOVCAIXA', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUMOVCAIXA);
   END IF;

   IF (V_EXCLUVENDA = 0) THEN
      INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
      VALUES (P_DSSISTLIMPEZ, 'VENDA', SYSDATE, P_NMOPERLIMPEZ, P_DTFINAL, 'VENDA', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUVENDA);
   END IF;

   IF (V_EXCLUITEMVENDA = 0) THEN
      INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
      VALUES (P_DSSISTLIMPEZ, 'ITEMVENDA', SYSDATE, P_NMOPERLIMPEZ, P_DTFINAL, 'ITEMVENDA', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUITEMVENDA);
   END IF;
   
   COMMIT;

   RAISE_APPLICATION_ERROR (-20101,  V_ERROR);

END;
/


-- VERSAO --
BEGIN ATUVEROBJ('LIMPEZA_VENDAS_GR','5.05.009'); END;
/

